# 📜 VroxLexer  

A **lightweight and efficient lexer** for tokenizing text, supporting **keywords, numbers, strings, identifiers, operators, comments, and more**! 🚀  

## ✨ Features  

- 🔍 **Keyword Detection** – Recognizes keywords like `if`, `else`, `while`, etc.  
- 🔢 **Number Recognition** – Supports integers, floats, and scientific notation.  
- 📝 **String Parsing** – Detects both single (`'text'`) and double (`"text"`) quotes.  
- 🏷 **Identifiers** – Recognizes variable names, function names, etc.  
- 🔧 **Operator Detection** – Identifies operators like `+`, `-`, `*`, `/`, `=` and more.  
- 💬 **Comment Handling** – Supports both `// single-line` and `/* multi-line */` comments.  
- 📑 **Punctuation Support** – Detects `{`, `}`, `;`, `,`, `(`, `)`, etc.  
- ⚡ **Memory-Efficient Processing** – Uses **file streams** instead of loading everything into RAM.  
- 🔗 **Extensible API** – Easily add **custom token rules** for any syntax.  

---

